//-----------------------------------------------------------
//
//-----------------------------------------------------------
class ChosenMatch extends xDeathMatch;
var array<PathNode> nodeArray;
var int myArrayIndex;
var array<Pawn> pawnArray;
var ChosenPawn theChosenOne;

// I need this function in order to get a random pathnode later
function getNodes()
{
  local int newArrayLength;
  local PathNode arrayNode;
  local int arrayIndex;

  newArrayLength = 0;
  arrayIndex = 0;

  foreach AllActors (class'PathNode', arrayNode)
  {
    newArrayLength++;
  }  // end for
  nodeArray.Length = newArrayLength;
  // now populate the array
  foreach AllActors (class'PathNode', arrayNode)
  {
    nodeArray[arrayIndex] = arrayNode;
    arrayIndex++;
  }  // end for
}  // end getNodes

function getPawns()
{
  local int pawnArrayLength;
  local Pawn addPawn;
  local int pawnArrayIndex;

  pawnArrayLength = 0;
  pawnArrayIndex = 0;

  foreach AllActors (class'Pawn', addPawn)
  {
    pawnArrayLength++;
  }  // end for
  pawnArray.Length = pawnArrayLength;
  // now populate the array
  foreach AllActors (class'Pawn', addPawn)
  {
    pawnArray[pawnArrayIndex] = addPawn;
    pawnArrayIndex++;
  }  // end for
}  // end getNodes

/*
*  closest node will return the path node closest to the passed actor
*/
function PathNode closestNode(Actor mySelf)
{
  local PathNode farNode;
  local PathNode pathNode;
  local float thisDistance;
  local float holdingDistance;
  local float xDistance;
  local float yDistance;
  local float lastDistance;
  // now get the first distance to use as an example
  thisDistance = 10000;

  // in the for loop, get the distance from the node the actor
  // if the distance is greatest so far, set that pathNode
  // equal to the furthest node
  foreach AllActors (class'PathNode', pathNode)
  {
    xDistance = abs(mySelf.Location.X - pathNode.Location.X);
    yDistance = abs(mySelf.Location.Y - pathNode.Location.Y);
    holdingDistance = xDistance+yDistance;

    if((holdingDistance < thisDistance)&&(holdingDistance>0)&&(holdingDistance!=lastDistance))
    {
      thisDistance = holdingDistance;
      farNode = pathNode;
    }  // end else if
  }  // end for
  lastDistance = thisDistance;
  return farNode;
}  // end getClosestNode
/*
*   returns a random node
*   I will try to return a node near a pawn currently in the game
*/
function PathNode randomNode()
{
  local int randNum;

  //getPawns();
  randNum = Rand(nodeArray.Length);
  //return closestNode(pawnArray[randNum]);
  return nodeArray[randNum];
}

function ChosenMoneyPickup SpawnChosenMoney(string typeOfMoney)//, potatoStart spawnPoint)
{
    local ChosenMoneyPickup myNewMoney;
    local class<ChosenMoneyPickup> ThisNewMoneyClass;
    //local potatoSquad PS;
    local PathNode chosenMoneyLocation;

    chosenMoneyLocation = randomNode();
    ThisNewMoneyClass = class<ChosenMoneyPickup>(DynamicLoadObject(typeOfMoney, class'Class'));
    if (ThisNewMoneyClass != None) {
       myNewMoney = Spawn(ThisNewMoneyClass,,,chosenMoneyLocation.Location, chosenMoneyLocation.Rotation);
    }
    else
    {
      Level.Game.Broadcast(self, "MoneyError");
    }

    return myNewMoney;
}

function StartMatch()
{
	local array<ChosenMoneyPickup> thisMoney;
    //local int x;

    thisMoney.Length = 6;
    getNodes();

    //for(x = 0; x<5; x++)
    //{
      thisMoney[0] = SpawnChosenMoney("Chosen.ChosenMoneyPickup");
      thisMoney[1] = SpawnChosenMoney("Chosen.ChosenMoneyPickup");
      thisMoney[2] = SpawnChosenMoney("Chosen.ChosenMoneyPickup");
      thisMoney[3] = SpawnChosenMoney("Chosen.ChosenMoneyPickup");
      thisMoney[4] = SpawnChosenMoney("Chosen.ChosenMoneyPickup");
    //}

    Super.StartMatch();

}

// override timer so we make sure we always have enough chosen level
// in the match
state MatchInProgress
{
  function Timer()
  {
    // cycle through the players and make sure theres enough chosen level up in the
    // match
    local ChosenPawn checkPawn;
    local int totalChosenLevel;
    local ChosenMoneyPickup checkPickup, newPickup, destroyPickup;

    totalChosenLevel = 0;

    foreach allactors(class'ChosenPawn', checkPawn)
    {
      if(checkPawn.Controller != none)
      {
        totalChosenLevel = totalChosenLevel + ChosenPlayerReplicationInfo(checkPawn.Controller.PlayerReplicationInfo).chosenLevel;
        //level.game.broadcast(self, ChosenPlayerReplicationInfo(checkPawn.Controller.PlayerReplicationInfo).isChosen);
      }
    }
    foreach allactors(class'ChosenMoneyPickup', checkPickup)
    {
      totalChosenLevel = totalChosenLevel + checkPickup.ChosenPickupAmount;
    }
    // if the chosen level + the value of all the pickups on the map is less than 5
    // spawn another one.
    if(totalChosenLevel < 5)
    {
      //level.game.Broadcast(self, "Adding Chosen Level up");
      newPickup = SpawnChosenMoney("Chosen.ChosenMoneyPickup");
    }

    // if its greater than 5, destroy pickup if we can
    if(totalChosenLevel > 5)
    {
      foreach allactors(class'ChosenMoneyPickup', checkPickup)
      {
        destroyPickup = checkPickup;
      }
      destroyPickup.Destroy();
    }
    // before checking endGame, have to populate the potPlayer
    foreach allactors (Class 'ChosenPawn',checkPawn)
    {
      if(checkPawn.PlayerReplicationInfo != none)
      {
        if ( CheckEndGame(checkPawn.PlayerReplicationInfo, "LastMan") ) {
          bGameEnded = true;
          TriggerEvent('EndGame', self, None);
          EndGame(None,"TimeLimit");
        }
      }
    }
    super.Timer();
  }
}

function bool CheckEndGame(PlayerReplicationInfo Winner, string Reason)
{
	local Controller P;
	local PlayerController player;
    local bool endGame;
    local ChosenPawn checkPawn;
    local ChosenPawn winnerPawn;


    endGame = true;
    foreach AllActors(class'ChosenPawn', checkPawn)
    {
        if((!checkPawn.isFrozen)&&(!checkPawn.isChosen))
        {
          endGame = false;
        }
    }

    if(endGame)
    {
    // find which player is chosen
    foreach AllActors(class'ChosenPawn', checkPawn)
    {
      if(checkPawn.isChosen)
      {
        winnerPawn = checkPawn;
        GameReplicationInfo.Winner = checkPawn.Controller.PlayerReplicationInfo;
      }
    }

	EndTime = Level.TimeSeconds + EndTimeDelay;

	if ( Winner != None )
		EndGameFocus = Controller(Winner.Owner).Pawn;
	if ( EndGameFocus != None )
		EndGameFocus.bAlwaysRelevant = true;

	for ( P=Level.ControllerList; P!=None; P=P.nextController )
	{
		player = PlayerController(P);
		if ( Player != None )
		{
			PlayWinMessage(Player, (ChosenPlayerReplicationInfo(Player.PlayerReplicationInfo).gameWinner == GameReplicationInfo.Winner));
			player.ClientSetBehindView(true);
			if ( EndGameFocus != None )
            {
				Player.ClientSetViewTarget(EndGameFocus);
                Player.SetViewTarget(EndGameFocus);
            }
			player.ClientGameEnded();
			if ( CurrentGameProfile != None )
				CurrentGameProfile.bWonMatch = (ChosenPlayerReplicationInfo(Player.PlayerReplicationInfo).gameWinner == GameReplicationInfo.Winner);
		}
		P.GameHasEnded();
	}
	PlayEndOfMatchMessage();
	return true;
	}
	else
	  return false;
}


function PlayEndOfMatchMessage()
{
	local controller C;

    if ( (PlayerReplicationInfo(GameReplicationInfo.Winner).Deaths == 0)
		&& (PlayerReplicationInfo(GameReplicationInfo.Winner).Score >= 5) )
    {
		for ( C = Level.ControllerList; C != None; C = C.NextController )
		{
			if ( C.IsA('PlayerController') )
			{
				if ( (C.PlayerReplicationInfo == GameReplicationInfo.Winner) || C.PlayerReplicationInfo.bOnlySpectator )
					PlayerController(C).PlayStatusAnnouncement(AltEndGameSoundName[0],1,true);
				else
					PlayerController(C).PlayStatusAnnouncement(AltEndGameSoundName[1],1,true);
			}
		}
	}
    else
    {
		for ( C = Level.ControllerList; C != None; C = C.NextController )
		{
			if ( C.IsA('PlayerController') && !C.PlayerReplicationInfo.bOnlySpectator )
			{
				if (C.PlayerReplicationInfo == GameReplicationInfo.Winner)
					PlayerController(C).PlayStatusAnnouncement(EndGameSoundName[0],1,true);
				else
					PlayerController(C).PlayStatusAnnouncement(EndGameSoundName[1],1,true);
			}
		}
	}
}

state StallingMatchEnd
{
	function RestartPlayer( Controller aPlayer ) {}
	function ScoreKill(Controller Killer, Controller Other) {}
	function int ReduceDamage( int Damage, pawn injured, pawn instigatedBy, vector HitLocation, vector Momentum, class<DamageType> DamageType )
	{
		return 0;
	}

	function bool ChangeTeam(Controller Other, int num, bool bNewTeam)
	{
		return false;
	}

    function Timer()
    {
	}


    function bool NeedPlayers()
    {
        return false;
    }

    function BeginState()
    {
	}
    function FreezeOdysseus() {
       local ChosenPlayer ody;
       foreach AllActors( class'ChosenPlayer', ody ) {
          ody.Freeze();
          ody.myHUD.bShowScoreBoard = false;
          break;
       }
	}
Begin:
    FreezeOdysseus();
    PlayEndOfMatchMessage();
    Sleep(6.0);
    GoToState('MatchOver');
}


DefaultProperties
{
     DMSquadClass=Class'Chosen.ChosenSquadAI'
     DefaultEnemyRosterClass="Chosen.ChosenRoster"
     EndMessageWait=0
     SinglePlayerWait=6
     DefaultPlayerClassName="Chosen.ChosenPawn"
     HUDType="Chosen.ChosenHud"
     PlayerControllerClassName="Chosen.ChosenPlayer"
     GameName="Chosen"
     Acronym="DM"
     MapPrefix="DM"
     Description="Do you have what it takes to become Chosen?"
}
