//-----------------------------------------------------------
//
//-----------------------------------------------------------
class ChosenWeapon extends Weapon
      config(user);

var(FirstPerson) float NewEffectOffset;

function bool HandlePickupQuery( pickup Item )
{
   if ( class == Item.InventoryType )
   {
     self.Destroy();
     return false;
   }
   if ( Inventory == None )
     return false;
   return Inventory.HandlePickupQuery(Item);
}

function bool CanThrow()
{
  return false;
}

function bool BotFire(bool bFinished, name FiringMode)
{
  if((ChosenPawn((Instigator.Controller).Enemy)!= none)&&(!ChosenPawn(Instigator.Controller.Enemy).isFrozen))
    return super.BotFire(bFinished, FiringMode);
  else
  {
    if(ChosenBot(Instigator.Controller) != none)
      ChosenBot(Instigator.Controller).findNewEnemy();
  }
  return false;
}

simulated function vector GetEffectStart()
{
    local Vector X,Y,Z;

	if ( Instigator.IsFirstPerson() && (Hand == 0) )
	{
        GetViewAxes(X, Y, Z);
        if ( class'PlayerController'.Default.bSmallWeapons || Level.bClassicView )
			return (Instigator.Location +
				Instigator.CalcDrawOffset(self) +
				SmallEffectOffset.X * X  +
				SmallEffectOffset.Y * Y * Hand -
				NewEffectOffset * Z);
        else
			return (Instigator.Location +
				Instigator.CalcDrawOffset(self) +
				EffectOffset.X * X +
				EffectOffset.Y * Y * Hand +
				EffectOffset.Z * Z);
	}
	return Super.GetEffectStart();
}


function float SuggestAttackStyle()
{
	return 0.8;
}

function float SuggestDefenseStyle()
{
    return -0.4;
}

simulated event WeaponTick(float dt)
{
	local PlayerController PC;
	local ChosenWeaponFire LF;

	PC = PlayerController(Instigator.Controller);
	LF = ChosenWeaponFire(FireMode[1]);

	if (PC != None && LF != None)
	{
		if (!LF.bLinkFeedbackPlaying)
		{
			LF.bLinkFeedbackPlaying = true;
			PC.ClientPlayForceFeedback(LF.MakeLinkForce);
			if (!LF.bIsFiring)
				PC.ClientPlayForceFeedback("BLinkGunBeam1");
		}
		else if (LF.bLinkFeedbackPlaying)
		{
			LF.bLinkFeedbackPlaying = false;
			PC.StopForceFeedback("BLinkGunBeam1");
		}
	}
}

simulated function UpdateLinkColor( LinkAttachment.ELinkColor Color )
{
  return;
}

function HolderDied()
{
  self.Destroy();
}
defaultproperties
{
  FireModeClass(1)=Class'Chosen.ChosenWeaponFire'
  FireModeClass(0)=Class'Chosen.ChosenWeaponFire'
  ItemName="Cho'sen"
  AttachmentClass=Class'Chosen.ChosenWeaponAttachment'
  PickupClass=Class'Chosen.ChosenWeaponPickup'
  NewEffectOffset=5.000000
  PutDownAnim="PutDown"
  IdleAnimRate=0.030000
  SelectSound=Sound'WeaponSounds.LinkGun.SwitchToLinkGun'
  SelectForce="SwitchToLinkGun"
  AIRating=5
  CurrentRating=5
  bMatchWeapons=True
  EffectOffset=(X=100.000000,Y=25.000000,Z=-3.000000)
  DisplayFOV=60.000000
  Priority=1
  DefaultPriority=1
  HudColor=(B=128,R=128)
  SmallViewOffset=(X=10.000000,Y=4.000000,Z=-9.000000)
  CenteredOffsetY=-12.000000
  CenteredRoll=3000
  CenteredYaw=-300
  InventoryGroup=15
  PlayerViewOffset=(X=-2.000000,Y=-2.000000,Z=-3.000000)
  PlayerViewPivot=(Yaw=500)
  BobDamping=1.575000
  IconMaterial=Texture'InterfaceContent.HUD.SkinA'
  IconCoords=(X1=200,Y1=190,X2=321,Y2=280)
  Mesh=SkeletalMesh'Weapons.LinkGun_1st'
  UV2Texture=Shader'XGameShaders.WeaponShaders.WeaponEnvShader'
}

