//-----------------------------------------------------------
//
//-----------------------------------------------------------
class ChosenWeaponFire extends WeaponFire;


var ChosenBeamEffect Beam;
var sound MakeLinkSound;
var float UpTime;
var float LinkBreakTime;
var() float LinkBreakDelay;
var float LinkScale[6];
var() float AimCone;
var() float MaxDist;

var String MakeLinkForce;

var() class<DamageType> DamageType;
var() int Damage;
var() float MomentumTransfer;

var() float TraceRange;
var() float LinkFlexibility;

var		bool bDoHit;
var()	bool bFeedbackDeath;
var		bool bInitAimError;
var		bool bLinkFeedbackPlaying;
var		bool bStartFire;

var rotator DesiredAimError, CurrentAimError;

simulated function DestroyEffects()
{
	Super.DestroyEffects();
    if ( Level.NetMode != NM_Client )
    {
        if (Beam != None)
            Beam.Destroy();
    }
}

simulated function ModeTick(float dt)
{
    local Vector StartTrace, EndTrace, X,Y,Z;
    local Vector HitLocation, HitNormal, EndEffect;
    local Actor Other;
    local Rotator Aim;
    local ChosenWeapon ChosenWeapon;
    local float MT, Step, ls;
	local bot B;
	local bool bShouldStop;
    local int AdjustedDamage;
	//local GhostBeamEffect LB;

    if (!bIsFiring)
    {
		bInitAimError = true;
        return;
    }
    ChosenWeapon = ChosenWeapon(Weapon);


    if (FlashEmitter != None)
    {

        FlashEmitter.Skins[0] = Texture'XEffectMat.link_muz_red';
        // adjust muzzle flash size to link size
	    FlashEmitter.mSizeRange[0] = FlashEmitter.default.mSizeRange[0] * (ls*0.5 + 1);
	    FlashEmitter.mSizeRange[1] = FlashEmitter.mSizeRange[0];
    }

    if (((UpTime > 0.0) || (Instigator.Role < ROLE_Authority)) )//ChosenWeapon.Ammo[ThisModeNum].AmmoAmount >= AmmoPerFire &&
    {
        UpTime -= dt;
        ChosenWeapon.GetViewAxes(X,Y,Z);

        // the to-hit trace always starts right in front of the eye
        StartTrace = Instigator.Location + Instigator.EyePosition() + X*Instigator.CollisionRadius;

        //TraceRange = default.TraceRange + GhostGun.Links*250;
        TraceRange = default.TraceRange + 250;


            if ( Bot(Instigator.Controller) != None )
            {
				if ( bInitAimError )
				{
					CurrentAimError = AdjustAim(StartTrace, AimError);
					bInitAimError = false;
				}
				else
				{
					BoundError();
					CurrentAimError.Yaw = CurrentAimError.Yaw + Instigator.Rotation.Yaw;
				}
				// smooth aim error changes
				Step = 7500.0 * dt;
				if ( DesiredAimError.Yaw ClockWiseFrom CurrentAimError.Yaw )
				{
					CurrentAimError.Yaw += Step;
					if ( !(DesiredAimError.Yaw ClockWiseFrom CurrentAimError.Yaw) )
					{
						CurrentAimError.Yaw = DesiredAimError.Yaw;
						DesiredAimError = AdjustAim(StartTrace, AimError);
					}
				}
				else
				{
					CurrentAimError.Yaw -= Step;
					if ( DesiredAimError.Yaw ClockWiseFrom CurrentAimError.Yaw )
					{
						CurrentAimError.Yaw = DesiredAimError.Yaw;
						DesiredAimError = AdjustAim(StartTrace, AimError);
					}
				}
				CurrentAimError.Yaw = CurrentAimError.Yaw - Instigator.Rotation.Yaw;
				if ( BoundError() )
					DesiredAimError = AdjustAim(StartTrace, AimError);
				CurrentAimError.Yaw = CurrentAimError.Yaw + Instigator.Rotation.Yaw;

				Aim = Rotator(Instigator.Controller.Target.Location - StartTrace);

				Aim.Yaw = CurrentAimError.Yaw;

				// save difference
				CurrentAimError.Yaw = CurrentAimError.Yaw - Instigator.Rotation.Yaw;
			}
			else
	            Aim = AdjustAim(StartTrace, AimError);

            X = Vector(Aim);
            EndTrace = StartTrace + TraceRange * X;


        Other = Trace(HitLocation, HitNormal, EndTrace, StartTrace, true);
        if (Other != None && Other != Instigator)
			EndEffect = HitLocation;
		else
			EndEffect = EndTrace;
		if (Beam != None)
			Beam.EndEffect = EndEffect;

		if ( Instigator.Role < ROLE_Authority )
			return;

        if (Other != None && Other != Instigator)
        {

                // beam is updated every frame, but damage is only done based on the firing rate
                if (bDoHit)
                {
                    if (Beam != None)
						Beam.bLockedOn = false;

                    Instigator.MakeNoise(1.0);

                    AdjustedDamage = Damage*(1.5*1);

                    if ( !Other.bWorldGeometry )
                    {
                        if (Level.Game.bTeamGame && Pawn(Other) != None && (Pawn(Other).PlayerReplicationInfo != None)
							&& Pawn(Other).PlayerReplicationInfo.Team == Instigator.PlayerReplicationInfo.Team) // so even if friendly fire is on you can't hurt teammates
                            AdjustedDamage = 0;

                        if (Other.Physics == PHYS_Falling || Other.Physics == PHYS_Flying || Other.Physics == PHYS_Swimming)
                            MT = 1 * MomentumTransfer;
                        else
                            MT = 0.0;
                        Other.TakeDamage(AdjustedDamage, Instigator, HitLocation, MT*X, DamageType);

                        if (Beam != None)
                            Beam.bLockedOn = true;
                    }
                }
        }

		if ( bShouldStop )
			B.StopFiring();
		else
		{
			// beam effect is created and destroyed when firing starts and stops

			if ( (Beam == None) && bIsFiring )
				Beam = Spawn(class'ChosenBeamEffect',Instigator);

			if (Beam != None)
			{
				Beam.bHitSomething = (Other != None);
				Beam.EndEffect = EndEffect;
			}
		}
    }
    else
    {
        StopFiring();
    }

    bStartFire = false;
    bDoHit = false;
}

function bool BoundError()
{
	CurrentAimError.Yaw = CurrentAimError.Yaw & 65535;
	if ( CurrentAimError.Yaw > 2048 )
	{
		if ( CurrentAimError.Yaw < 32768 )
		{
			CurrentAimError.Yaw = 2048;
			return true;
		}
		else if ( CurrentAimError.Yaw < 63487 )
		{
			CurrentAimError.Yaw = 63487;
			return true;
		}
	}
	return false;
}
function DoFireEffect()
{
    bDoHit = true;
    UpTime = FireRate+0.1;
}

function PlayFiring()
{
	//if (Weapon.Ammo[ThisModeNum].AmmoAmount >= AmmoPerFire)
	ClientPlayForceFeedback("BLinkGunBeam1");
    Super.PlayFiring();
}

function StopFiring()
{
    if (Beam != None)
    {
        Beam.Destroy();
        Beam = None;
    }
    bStartFire = true;
    bFeedbackDeath = false;
   StopForceFeedback("BLinkGunBeam1");
}





function bool IsLinkable(Actor Other)
{
    return false;
}


defaultproperties
{
     MakeLinkSound=Sound'WeaponSounds.LinkGun.LinkActivated'
     LinkBreakDelay=0.500000
     LinkScale(1)=0.500000
     LinkScale(2)=0.900000
     LinkScale(3)=1.200000
     LinkScale(4)=1.400000
     LinkScale(5)=1.500000
     MakeLinkForce="LinkActivated"
     Damage=15
     MomentumTransfer=20000.000000
     TraceRange=1100.000000
     LinkFlexibility=0.640000
     bInitAimError=True
     FireAnim="AltFire"
     FireEndAnim="None"
     NoAmmoSound=ProceduralSound'WeaponSounds.PReload5.P1Reload5'
     FireRate=0.200000
     ShakeRotMag=(Z=60.000000)
     ShakeRotRate=(Z=4000.000000)
     ShakeRotTime=6.000000
     ShakeOffsetMag=(Y=1.000000,Z=1.000000)
     ShakeOffsetRate=(X=1000.000000,Y=1000.000000,Z=1000.000000)
     ShakeOffsetTime=3.000000
     BotRefireRate=0.990000
     WarnTargetPct=0.200000
     bPawnRapidFireAnim=True
     FlashEmitterClass=Class'XEffects.LinkMuzFlashBeam1st'
     AmmoPerFire=0
     DamageType=Class'Chosen.ChosenDamage'
     AmmoClass=Class'Chosen.ChosenAmmo'
}


